Subject: A slight inconvenience with 'git archive --format=tar'

From: Rafał Mużyło <[email-masked]>
Date: Wed, 13 Jun 2012 16:47:58 +0200

I just stumbled upon this while checking a few mailing lists.
I haven't found any mails about in in the archives yet, so I assume, that
no mail have been written yet.

The problem is described here:
http://sourceforge.net/projects/sevenzip/forums/forum/45798/topic/5322604

Basically, while this is not a problem for GNU tar, the correct checksum
should be computed using unsigned values.

Attached trivial testcase shows the difference.

Patch making the change shown in the testcase also attached.

--- archive-tar.c	2012-04-26 21:25:49.000000000 +0200
+++ archive-tar.c	2012-06-13 16:43:59.220945967 +0200
@@ -104,11 +104,11 @@ static unsigned int ustar_header_chksum(
 	char *p = (char *)header;
 	unsigned int chksum = 0;
 	while (p < header->chksum)
-		chksum += *p++;
+		chksum += (unsigned char)*p++;
 	chksum += sizeof(header->chksum) * ' ';
 	p += sizeof(header->chksum);
 	while (p < (char *)header + sizeof(struct ustar_header))
-		chksum += *p++;
+		chksum += (unsigned char)*p++;
 	return chksum;
 }